
import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import javax.microedition.io.*;
import java.io.*;
//import com.siemens.mp.game.Sound;


public class OSC extends MIDlet implements CommandListener
{
   static final String EXIT_COMMAND_LABEL = "Exit";
   static final String COMMAND_LABEL1 = "Enable";
   static final String COMMAND_LABEL2 = "Disable";
   static final String COMMAND_LABEL3 = "Auto mode";
   Display display;

   OSCCanvas canvas;

   InputStream iStream;
   OutputStream oStream;
   CommConnection commConn;

   public void sendcommand(int c)
        {
        try
            {
            oStream.write((char)c);
            }
        catch (Exception e){}
        }

   protected void destroyApp (boolean b)
   {
      sendcommand(0);
        try{
        iStream.close();
        oStream.close();
        commConn.close();
        } catch (Exception e) {}

      display.setCurrent(null);
      this.notifyDestroyed();       // notify KVM
   }

   protected void pauseApp ()
   {}

   protected void startApp ()
   {
      canvas = new OSCCanvas();

      display = Display.getDisplay(this);

      Command exitCommand  = new Command(EXIT_COMMAND_LABEL , Command.SCREEN, 3);
      Command Command1 = new Command(COMMAND_LABEL1, Command.SCREEN, 2);
      Command Command2 = new Command(COMMAND_LABEL2, Command.SCREEN, 1);
      Command Command3 = new Command(COMMAND_LABEL3, Command.SCREEN, 0);
      canvas.addCommand(exitCommand);
//      canvas.addCommand(Command1);
//      canvas.addCommand(Command2);
      canvas.addCommand(Command3);
      canvas.setCommandListener(this);

      display.setCurrent(canvas);
      canvas.osc=this;


   try{
   canvas.img=Image.createImage("/osc.png");

   commConn =(CommConnection)Connector.open("comm:COM0;baudrate=9600", Connector.READ_WRITE,true);
   iStream = commConn.openInputStream();
   oStream = commConn.openOutputStream();
//   String sMessage = "send";
//   oStream.write(sMessage.getBytes());
   } catch (Exception e) {}

   Thread tRead=new Thread()
   {
   public void run()
       {
       int cc=0;
       int modecount=0;
       while (true)
           {
           try {cc=iStream.read();} catch (Exception e){cc=0;}
           if ((cc==0xff)&&(!canvas.pause))
              {
              int val1=0;
              int sumv=0;
              int suma=0;
              for (canvas.vi=0;canvas.vi<100;canvas.vi++)
                {
                try {val1=iStream.read();} catch (Exception e){val1=0;}
                sumv+=(val1-128); //average
                suma+=Math.abs(val1-128); //average
                canvas.v1[canvas.vi]=127-(val1>>1)+48;
                }
              suma/=100;
              canvas.val=sumv/100;
              if (modecount<5) modecount++;
              if ((canvas.automode)&&(modecount>2))
                 {
                 int himode=canvas.mode>>6;
                 int lomode=canvas.mode&0x0f;
                 if (suma>124)
                    if (himode<2)
                       {canvas.mode=((himode+1)<<6)+lomode;sendcommand(canvas.mode);modecount=0;}
                 if (suma<10)
                    if (himode>0)
                       {canvas.mode=((himode-1)<<6)+lomode;sendcommand(canvas.mode);modecount=0;}
                 }
              canvas.repaint();
              }
           }
       }
   };

   tRead.start();
   canvas.mode=3;
   sendcommand(canvas.mode);
   }

public void commandAction(Command c, Displayable d)
    {
    String label=c.getLabel();
    if (label==EXIT_COMMAND_LABEL)
        {
        destroyApp(false);
        }
    else if (label==COMMAND_LABEL1)
        {
//        sendcommand(canvas.mode);
        }
    else if (label==COMMAND_LABEL2)
        {
//        sendcommand(0);
        }
    else if (label==COMMAND_LABEL3)
        {
        canvas.automode=!canvas.automode;
        }

    }

}


class OSCCanvas extends Canvas
    {
    double val;
    int []v1=new int [128];
//    int []v2=new int [128];
    int vi=0;
    Image img;
    int mode;
    OSC osc;
    boolean pause=false;
    boolean automode=false;

    protected void keyPressed(int keyCode)
        {
        int himode=mode>>6;
        int lomode=mode&0x0f;
        switch (keyCode)
                {
                case KEY_NUM5:pause=!pause;break;
                case LEFT:
                case -61:
                case -3:
                case KEY_NUM4:if (lomode>2){mode--;osc.sendcommand(mode);}break;
                case RIGHT:
                case -62:
                case -4:
                case KEY_NUM6:if (lomode<6){mode++;osc.sendcommand(mode);}break;
                case UP:
                case -59:
                case -1:
                case KEY_NUM2:if (himode<2){mode=((himode+1)<<6)+lomode;osc.sendcommand(mode);}break;
                case DOWN:
                case -60:
                case -2:
                case KEY_NUM8:if (himode>0){mode=((himode-1)<<6)+lomode;osc.sendcommand(mode);}break;
                }
        }

    public void paint(Graphics g)
        {
        Font font;
        g.drawImage(img,0,0,0);
        g.setColor(255,255,255);

        font=Font.getFont(Font.FACE_PROPORTIONAL, Font.STYLE_BOLD, Font.SIZE_SMALL  );
        g.setFont(font);


        String sm="OFF";
        switch (mode&0x0F)
                {
                case 1:sm="10us/div";break;
                case 2:sm="300us/div";break;
                case 3:sm="1ms/div";break;
                case 4:sm="10ms/div";break;
                case 5:sm="100ms/div";break;
                case 6:sm="1s/div";break;
                }
        if (pause) sm="PAUSE";

        g.drawString(sm, this.getWidth()-8, 14, Graphics.RIGHT|Graphics.BASELINE);

        if (automode)
           g.drawString("A", this.getWidth()/2, 14, Graphics.LEFT|Graphics.BASELINE);

        int k=1;
        switch (mode>>6)
                {
                case 0:sm="0.5V/div";k=1;break;
                case 1:sm="5V/div";k=10;break;
                case 2:sm="50V/div";k=100;break;
                case 3:sm="500V/div";k=1000;break;
                }

        g.drawString(sm, this.getWidth()-8, 28, Graphics.RIGHT|Graphics.BASELINE);

        for (int i=0;i<99;i++) g.drawLine(i+16,v1[i],i+1+16,v1[i+1]);

        font=Font.getFont(Font.FACE_PROPORTIONAL, Font.STYLE_BOLD, Font.SIZE_LARGE );
        g.setFont(font);
        String vs1=""+(val*k*2.5/255);
        if (vs1.length()<4) vs1+="00";
        g.drawString(vs1.substring(0,5), 8, 28, Graphics.LEFT|Graphics.BASELINE);
        }


    }
